routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\BukuTamuController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\FasilitasController;
use App\Http\Controllers\FasilitasKamarController;
use App\Http\Controllers\KamarController;
use App\Http\Controllers\PendapatanController;
use App\Http\Controllers\TipeKamarController;
use App\Http\Controllers\TransaksiController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [DashboardController::class, 'home'])->name('landing');
Route::get('kamar-hotel', [DashboardController::class, 'kamar'])->name('kamar.hotel');
Route::get('kamar-hotel-show/{id}', [DashboardController::class, 'showKamar'])->name('kamar.hotel.show');
Route::get('fasilias-hotel', [DashboardController::class, 'fasilitas'])->name('fasilitas.hotel');

Route::group(['middleware' => 'guest'], function(){
    Route::get('login', [AuthController::class, 'login'])->name('login');
    
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
    
    Route::post('signup', [AuthController::class, 'signup'])->name('signup');
    
    Route::get('register', [AuthController::class, 'register'])->name('register');
});

Route::group(['middleware' => 'auth'], function(){
    Route::post('logout', [AuthController::class, 'logout'])->name('logout');
    Route::resource('cart', CartController::class);
    Route::post('cart-destroy-all', [CartController::class, 'destroyAll'])->name('cart.destroy.all');
    Route::get('transaksi', [TransaksiController::class, 'index'])->name('transaksi.index');
    Route::post('transaksi-store', [TransaksiController::class, 'store'])->name('transaksi.store');
    Route::get('invoice/{id?}', [TransaksiController::class, 'invoice'])->name('transaksi.invoice');
    Route::get('invoice-show/{id?}', [TransaksiController::class, 'show'])->name('transaksi.invoice.show');
    Route::group(['middleware' => ['hasrole:admin']], function(){
        Route::resource('kamar', KamarController::class);
        Route::resource('fasilitas', FasilitasController::class);
        Route::resource('fasilitas-kamar', FasilitasKamarController::class);
        Route::resource('tipe-kamar', TipeKamarController::class);
    });
    Route::group(['middleware' => ['hasrole:guider']], function(){
        Route::get('buku-tamu', [BukuTamuController::class, 'index'])->name('buku.tamu.index');
        Route::get('buku-tamu/{id?}/show', [BukuTamuController::class, 'show'])->name('buku.tamu.show');
        Route::put('buku-tamu/{id?}/update', [BukuTamuController::class, 'update'])->name('buku.tamu.update');
        Route::get('pendapatan', [PendapatanController::class, 'index'])->name('pendapatan.index');
        Route::post('pendapatan/total', [PendapatanController::class, 'getTotalPendapatan'])->name('pendapatan.total');
    });
});

app/Models/Kamar.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Kamar extends Model
{
    use HasFactory;
    protected $guarded = [];

    public function fasilitases(){
        return $this->hasMany(FasilitasKamar::class);
    }

    public function tipeKamar(){
        return $this->belongsTo(TipeKamar::class);
    }
}

app/Http/Controllers/KamarController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\KamarRequest;
use App\Models\Kamar;
use Illuminate\Support\Facades\Storage;
use Yajra\DataTables\Facades\DataTables;

class KamarController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        Kamar::with('tipeKamar')->get();
        if(request()->ajax()){
            return DataTables::of(Kamar::with('tipeKamar')->get())
                ->editColumn('harga', function($row){
                    return number_format($row->harga);
                })
                ->addColumn('_', function($row){
                    return '<button type="button" class="btn btn-info btn-sm" onclick="view('.$row->id.')">Lihat</button>
                        <button type="button" class="btn btn-warning text-light btn-sm" onclick="edit('.$row->id.')">Edit</button>
                        <button type="button" class="btn btn-danger btn-sm" onclick="destroy('.$row->id.')">Hapus</button>';
                })
                ->rawColumns(['_'])
                ->make(true);
        }
        return view('pages.kamar.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.kamar.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(KamarRequest $request)
    {
        $file = request()->file('banner');
        $ext  = $file->getClientOriginalExtension();
        $fileName = time().rand(0, 999999).'.'.$ext;
        $filePath = $file->storeAs('banners', $fileName, 'public');
        $req = [
            'name' => request('name'),
            'tipe_kamar_id' => request('tipe_kamar_id'),
            'jumlah' => request('jumlah'),
            'stok'   => request('jumlah'),
            'harga'  => request('harga'),
            'banner' => $filePath
        ];

        if(Kamar::create($req)){
            return response()->json([
                'status' => true,
                'message' => 'Kamar berhasil ditambahkan'
            ]);
        }
        return response()->json([
            'status' => false,
            'message' => 'Kamar gagal ditambahkan'
        ]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $model  = Kamar::find($id);
        return view('pages.kamar.show', compact('model'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $model  = Kamar::find($id);
        return view('pages.kamar.edit', compact('model'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(KamarRequest $request, $id)
    {
        $model = Kamar::find($id);
        $file = request()->file('banner');
        $jumlahTerpakai = ($model->stok - $model->jumlah);

        if($jumlahTerpakai < 0 && request('jumlah') < $model->jumlah){
            return response()->json([
                'status' => false,
                'message' => 'Kamar sudah terpakai, jumlah penyesuaian harus diatas jumlah awal'
            ]);
        }

        if($file){
            // delete file
            $path = str_replace('/', '\\', $model->banner);
            if(Storage::exists('public\\'.$path)){
                Storage::delete('public\\'.$model->banner);
            }

            // add file
            $ext  = $file->getClientOriginalExtension();
            $fileName = time().rand(0, 999999).'.'.$ext;
            $filePath = $file->storeAs('banners', $fileName, 'public');
        }

        $req = [
            'name' => request('name'),
            'tipe_kamar_id' => request('tipe_kamar_id'),
            'jumlah' => request('jumlah'),
            'harga'  => request('harga'),
            'stok'   =>  $jumlahTerpakai == 0 ? request('jumlah') : request('jumlah') - ($model->jumlah - $model->stok), 
            'banner' => $filePath ?? $model->banner
        ];

        if($model->update($req)){
            return response()->json([
                'status' => true,
                'message' => 'Kamar berhasil diperbarui'
            ]);
        }

        return response()->json([
            'status' => true,
            'message' => 'Kamar gagal ditambahkan'
        ]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $model = Kamar::find($id);
        $path = str_replace('/', '\\', $model->banner);
        if(Storage::exists('public\\'.$path)){
            Storage::delete('public\\'.$model->banner);
        }

        if($model->delete()){
            return response()->json([
                'status' => true,
                'message' => 'Kamar berhasil dihapus'
            ]);
        }

        return response()->json([
            'status' => false,
            'message' => 'Kamar gagal dihapus'
        ]);
    }
}

resources/views/pages/kamar/create.blade.php
{!! Form::open(['id' => 'formCreate', 'enctype' => 'multipart/form-data']) !!}
    @include('pages.kamar.form')
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
        <button type="button" class="btn btn-primary btn-sm" onclick="store()">Tambah</button>
    </div>
    <script>
        function showPreview(event){
            if(event.target.files.length > 0){
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#image').attr('src', e.target.result);
                };
                $('browse_gambar').attr('value', event.target.files);
                reader.readAsDataURL(event.target.files[0]);
            }
        }
    </script>
{!! Form::close() !!}

resources/views/pages/kamar/edit.blade.php
{!! Form::model($model, ['id' => 'formEdit', 'enctype' => 'multipart/form-data']) !!}
    @include('pages.kamar.form')
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
        <button type="button" class="btn btn-primary btn-sm" onclick="update({{ $model->id }})">Ubah</button>
    </div>
    <script>
        function showPreview(event){
            if(event.target.files.length > 0){
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#image').attr('src', e.target.result);
                };
                $('browse_gambar').attr('value', event.target.files);
                reader.readAsDataURL(event.target.files[0]);
            }
        }
    </script>
{!! Form::close() !!}

resources/views/pages/kamar/form.blade.php
<div class="mb-3 text-center">
    @if(isset($model))
        <img id="image" src="{{ asset('storage/'.$model->banner) }}" class="w-75 rounded" alt="">
    @else
        <img id="image" src="" class="w-75 rounded" alt="">
    @endif
</div>
<div class="form-group">
    <label for="tipe">Pilih Gambar</label>
    <div class="custom-file mb-3">
        <input name="banner" type="file" class="custom-file-input" id="browse_gambar" onchange="showPreview(event)" required>
        <label class="custom-file-label" for="browse_gambar">Pilih...</label>
    </div>
</div>
<div class="form-group">
    <label for="name">Nama</label>
    {!! Form::text('name', null, ['class' => 'form-control', 'id' => 'name']) !!}
</div>
<div class="form-group">
    <label for="tipe">Tipe Kamar</label>
    {!! Form::select('tipe_kamar_id', ['' => 'Pilih']+App\Models\TipeKamar::pluck('name', 'id')->toArray(),null, ['class' => 'form-control', 'id' => 'tipe_kamar']) !!}
</div>
<div class="form-group">
    <label for="tipe">Harga</label>
    {!! Form::number('harga', null, ['class' => 'form-control text-right', 'id' => 'harga']) !!}
</div>
<div class="form-group">
    <label for="tipe">Jumlah</label>
    {!! Form::number('jumlah', null, ['class' => 'form-control', 'id' => 'jumlah']) !!}
</div>

resources/views/pages/kamar/form_script.blade.php
<script>
    var table;
    $(() => {
        table = $('#table').DataTable({
            searching: false,
            lengthChange: false,
            info: false,
            paging: false,
            processing: true,
            serverSide: true,
            responsive: true,
            ajax: '',
            columns: [
                {data: 'name', name: 'kamars.name'},
                {data: 'tipe_kamar.name', name: 'tipe_kamar.name'},
                {data: 'harga', name: 'kamars.harga'},
                {data: 'jumlah', name: 'kamars.jumlah'},
                {data: 'stok', name: 'kamars.stok'},
                {data: '_', searchable: false}
            ]
        });
    });

    function create(){
        $.ajax({
            url: '{{ route('kamar.create') }}',
            success: (response) => {
                bootbox.dialog({
                    title: 'Tambah Kamar',
                    message: response,
                    closeButton: true
                });
            }
        })
    }

    function store(){
        let fd = new FormData();
        fd.append('_token', '{{ csrf_token() }}');
        fd.append('banner', $('#browse_gambar').prop('files')[0]);
        fd.append('tipe_kamar_id', $('#tipe_kamar').val());
        fd.append('harga', $('#harga').val());
        fd.append('name', $('#name').val());
        fd.append('jumlah', $('#jumlah').val());
        $('#formCreate .alert').remove();
        
        $.ajax({
            url: '{{ route('kamar.store') }}',
            type: 'post',
            cache: false,
            contentType: false,
            processData: false,
            data: fd,
            success: (response) => {
                if(response.status){
                    Swal.fire({
                        title: 'success',
                        text: response.message,
                        icon: 'success'
                    });
                    table.ajax.reload();
                }else {
                    Swal.fire({
                        title: 'gagal',
                        text: response.message,
                        icon: 'error'
                    });
                }
                bootbox.hideAll();
            },
            error: (err) => {
                var response = JSON.parse(err.responseText);
                $('#formCreate').prepend(validation(response));
            }
        });
    }

    function edit(id){
        let url = "{{ route('kamar.edit', ":id") }}"
        url = url.replace(':id', id);
        $.ajax({
            url,
            success: (response) => {
                bootbox.dialog({
                    title: 'Ubah Kamar',
                    message: response,
                    closeButton: true
                });
            }
        });
    }

    function update(id){
        let fd = new FormData();
        fd.append('_token', '{{ csrf_token() }}');
        fd.append('_method', 'PUT');
        fd.append('tipe_kamar_id', $('#tipe_kamar').val());
        fd.append('name', $('#name').val());
        fd.append('banner', $('#browse_gambar').prop('files')[0]);
        fd.append('harga', $('#harga').val());
        fd.append('jumlah', $('#jumlah').val());
        $('#formEdit .alert').remove();

        let url = "{{ route('kamar.update', ":id") }}";
        url = url.replace(':id', id);
        $.ajax({
            url,
            type: 'post',
            cache: false,
            contentType: false,
            processData: false,
            data: fd,
            success: (response) => {
                if(response.status){
                    Swal.fire({
                        title: 'success',
                        text: response.message,
                        icon: 'success'
                    });
                    table.ajax.reload();
                }else {
                    Swal.fire({
                        title: 'gagal',
                        text: response.message,
                        icon: 'error'
                    });
                }
                bootbox.hideAll();
            },
            error: (err) => {
                let response = JSON.parse(err.responseText);
                $('#formEdit').prepend(validation(response));
            }
        });
    }

    function view(id){
        let url = "{{ route('kamar.show', ":id") }}";
        url = url.replace(":id", id);

        $.ajax({
            url,
            success: (response) => {
                bootbox.dialog({
                    title: 'Detail Kamar',
                    message: response,
                    closeButton: true
                });
            }
        });
    }

    function destroy(id){
        let data = {'_token': "{{ csrf_token() }}", '_method': 'DELETE'};
        
        let url  = "{{ route('kamar.destroy', ":id") }}";
        url = url.replace(':id', id);

        Swal.fire({
            title: 'Yakin hapus data?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Hapus',
        }).then((result) => {
            if(result.isConfirmed){
                $.ajax({
                    url,
                    method: 'post',
                    data,
                    success: (response) => {
                        if(response.status){
                            Swal.fire({
                                title: 'success',
                                text: response.message,
                                icon: 'success'
                            });
                            table.ajax.reload();
                        }else {
                            Swal.fire({
                                title: 'gagal',
                                text: response.message,
                                icon: 'error'
                            });
                        }
                    }
                });
            }
        });
    }

    function validation(errors){
        var validations = '<div class="alert alert-danger">';
        $.each(errors.errors, function(i, error){
            validations += error[0]+'<br>';
        });
        validations += '</div>';
        return validations;
    }
</script>

resources/views/pages/kamar/index.blade.php
<x-adminLayout pageName="kamar">
    <div class="d-flex justify-content-end mb-3">
        <button class="btn btn-success btn-sm text-end" onclick="create()">Tambah</button>
    </div>
    <table class="table table-bordered table-condensed" id="table">
        <thead>
            <tr>
                <th>Nama</th>
                <th>Tipe Kamar</th>
                <th>Harga</th>
                <th>Jumlah</th>
                <th>Stok</th>
                <th>Aksi</th>
            </tr>
        </thead>
        <tbody></tbody>
    </table>
    @slot('script')
        @include('pages.kamar.form_script')
    @endslot
</x-adminLayout>

resources/views/pages/kamar/show.blade.php
{!! Form::model($model, ['id' => 'formShow']) !!}
    <div class="mb-5 text-center">
        <img id="image" src="{{ asset('storage/'.$model->banner) }}" class="w-75 rounded" alt="">
    </div>
    <div class="row">
        <div class="col-md-3">
            <h6>Nama Kamar :</h6>
        </div>
        <div class="col-md-9">
            <p>{{ $model->name }}</p>
        </div>
    </div>
    <div class="row">
        <div class="col-md-3">
            <h6>Tipe Kamar :</h6>
        </div>
        <div class="col-md-9">
            <p>{{ $model->tipeKamar->name }}</p>
        </div>
    </div>
    <div class="row">
        <div class="col-md-3">
            <h6>Jumlah :</h6>
        </div>
        <div class="col-md-9">
            <p>{{ $model->jumlah }}</p>
        </div>
    </div>
    <div class="row">
        <div class="col-md-3">
            <h6>Harga :</h6>
        </div>
        <div class="col-md-9">
            <p>Rp.{{ number_format($model->harga) }}</p>
        </div>
    </div>
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
    </div>
{!! Form::close() !!}